#ifndef AMD3DH
#define AMD3DH
#pragma option -w-pch -w-asc
#ifndef Release3DNow
union {
    float Single[8][2];
    long DWord[8][2];
    short Word[8][4];
    unsigned short UWord[8][4];
    char Byte[8][8];
    unsigned char UByte[8][8];
} MX;
struct {
    unsigned int IM:1, DM:1, ZM:1, OM:1, UM:1, PM:1, :2, PC:2, RC:2, X:1, :19, IE:1, DE:1, ZE:1, OE:1, UE:1, PE:1, SF:1,
        ES:1, C0:1, C1:1, C2:1, Top:3, C3:1, B:1, :16, Tag7:2, Tag6:2, Tag5:2, Tag4:2, Tag3:2, Tag2:2, Tag1:2, Tag0:2;
    unsigned long InstructionPointer[2], OperandPointer[2];
    long double St[8];
} FP;
asm {
    DEB = 0
    PMMX
    MMX MACRO
        IF DEB
            IRP OFFSET,0,1,2,3,4,5,6,7
                REG CATSTR <mm>,<&OFFSET>
                movq qword ptr[MX+OFFSET*8],REG
            ENDM
        ENDIF
    ENDM
    P586
    FPU MACRO
        IF DEB
            fsave   FP
            frstor  FP
        ENDIF
    ENDM
#else
asm {
    MMX MACRO
    ENDM
    FPU MACRO
    ENDM
#endif
    OP2 MACRO OP_SRC,OP_POINT,OP_SUB,OP_OFFSET
        OP_SUB SUBSTR <&OP_SRC>,OP_POINT + OP_OFFSET,1
        IFIDNI <2>,OP_SUB;      OP_SS = 0x40
        ELSEIFIDNI <4>,OP_SUB;  OP_SS = 0x80
        ELSEIFIDNI <8>,OP_SUB;  OP_SS = 0xc0
        ELSE;                   ERR <Error>
        ENDIF
        OP_SUB SUBSTR <&OP_SRC>,OP_POINT + OP_OFFSET + 1,1
        IFDIFI <]>,OP_SUB;      ERR <Error>
        ENDIF
    ENDM
    OP1 MACRO OP_EXX
        IFIDNI <eax>,OP_EXX;        OP_REG = 0
        ELSEIFIDNI <ecx>,OP_EXX;    OP_REG = 1
        ELSEIFIDNI <edx>,OP_EXX;    OP_REG = 2
        ELSEIFIDNI <ebx>,OP_EXX;    OP_REG = 3
        ELSEIFIDNI <esp>,OP_EXX;    OP_REG = 4
        ELSEIFIDNI <ebp>,OP_EXX;    OP_REG = 5
        ELSEIFIDNI <esi>,OP_EXX;    OP_REG = 6
        ELSEIFIDNI <edi>,OP_EXX;    OP_REG = 7
        ELSE;                       OP_REG = -1
        ENDIF
    ENDM
    OP0 MACRO OP_DST,OP_SRC
        OP_POINT INSTR  <&OP_SRC>,<[>
        IF OP_POINT EQ 1
            OP_MOD = 0
        ELSEIF OP_POINT NE 0
            OP_DISP SUBSTR <&OP_SRC>,1,OP_POINT - 1
            IF (OP_DISP GE 0x80) OR (OP_DISP LT -0x80); OP_MOD = 0x80
            ELSE;                                       OP_MOD = 0x40
            ENDIF
        ELSE
            ERR <Error>
        ENDIF
        OP_EXX SUBSTR <&OP_SRC>,OP_POINT + 1,3
        OP1 OP_EXX
        IF OP_REG NE -1
            OP_SUB SUBSTR <&OP_SRC>,OP_POINT + 4,1
            IF (OP_REG EQ 5) AND (OP_POINT EQ 1)
                OP_MOD = 0x40
                OP_DISP = 0
            ENDIF
            IFIDNI <]>,OP_SUB
                db  (OP_DST SHL 3) + OP_REG + OP_MOD
                IF OP_REG EQ 4; db  0x24
                ENDIF
                IF OP_MOD EQ 0x40;      db OP_DISP
                ELSEIF OP_MOD EQ 0x80;  dd OP_DISP
                ENDIF
            ELSEIFIDNI <+>,OP_SUB
                db (OP_DST SHL 3) + 4 + OP_MOD
                OP_BASE = OP_REG
                OP_EXX SUBSTR <&OP_SRC>,OP_POINT + 5,3
                OP1 OP_EXX
                IF (OP_REG NE 4) AND (OP_REG NE -1)
                    OP_SUB SUBSTR <&OP_SRC>,OP_POINT + 8,1
                    IFIDNI <]>,OP_SUB;      OP_SS = 0
                    ELSEIFIDNI <*>,OP_SUB;  OP2 OP_SRC,OP_POINT,OP_SUB,9
                    ELSE;                   ERR <Error>
                    ENDIF
                    db (OP_REG SHL 3) + OP_BASE + OP_SS
                ELSE
                    ERR <Error>
                ENDIF
                IF OP_MOD EQ 0x40;      db OP_DISP
                ELSEIF OP_MOD EQ 0x80;  dd OP_DISP
                ENDIF
            ELSEIFIDNI <*>,OP_SUB
                IF OP_REG EQ 4; ERR <Error>
                ENDIF
                db (OP_DST SHL 3) + 4
                OP2 OP_SRC,OP_POINT,OP_SUB,5
                db (OP_REG SHL 3) + 5 + OP_SS
                IFDEF OP_DISP;  dd OP_DISP
                ELSE;           dd 0
                ENDIF
            ELSE
                ERR <Error>
            ENDIF
        ELSEIF OP_MOD EQ 0
            OP_LEN SIZESTR <&OP_SRC>
            OP_ADR SUBSTR <&OP_SRC>,2,OP_LEN - 2
            OP_SUB SUBSTR <&OP_SRC>,OP_LEN,1
            IFIDNI <]>,OP_SUB
                db  (OP_DST SHL 3) + 5
                dd  OP_ADR
            ELSE
                ERR <Error>
            ENDIF
        ELSE
            ERR <Error>
        ENDIF
    ENDM
    OP  MACRO OP_DST0,OP_SRC0,OP_CODE
        db 0x0f,0x0f
        OP_DST SUBSTR <&OP_DST0>,1,2
        IFIDNI <mm>,OP_DST
            OP_DST SUBSTR <&OP_DST0>,3,1
            OP_SRC SUBSTR <&OP_SRC0>,1,2
            IFIDNI <mm>,OP_SRC
                OP_SRC SUBSTR <&OP_SRC0>,3,1
                db (OP_DST SHL 3) + OP_SRC + 0xc0
            ELSE
                OP0 OP_DST,OP_SRC0
            ENDIF
        ELSE
            ERR <Error>
        ENDIF
        db OP_CODE
    ENDM
    femms   MACRO;              db  0x0f,0x0e;      ENDM
    pi2fw   MACRO   DST,SRC;    OP  DST,SRC,0x0c;   ENDM
    pi2fd   MACRO   DST,SRC;    OP  DST,SRC,0x0d;   ENDM
    pf2iw   MACRO   DST,SRC;    OP  DST,SRC,0x1c;   ENDM
    pf2id   MACRO   DST,SRC;    OP  DST,SRC,0x1d;   ENDM
    pfnacc  MACRO   DST,SRC;    OP  DST,SRC,0x8a;   ENDM
    pfpnacc MACRO   DST,SRC;    OP  DST,SRC,0x8e;   ENDM
    pfcmpge MACRO   DST,SRC;    OP  DST,SRC,0x90;   ENDM
    pfmin   MACRO   DST,SRC;    OP  DST,SRC,0x94;   ENDM
    pfrcp   MACRO   DST,SRC;    OP  DST,SRC,0x96;   ENDM
    pfrsqrt MACRO   DST,SRC;    OP  DST,SRC,0x97;   ENDM
    pfsub   MACRO   DST,SRC;    OP  DST,SRC,0x9a;   ENDM
    pfadd   MACRO   DST,SRC;    OP  DST,SRC,0x9e;   ENDM
    pfcmpgt MACRO   DST,SRC;    OP  DST,SRC,0xa0;   ENDM
    pfmax   MACRO   DST,SRC;    OP  DST,SRC,0xa4;   ENDM
    pfrcpit1 MACRO  DST,SRC;    OP  DST,SRC,0xa6;   ENDM
    pfrsqit1 MACRO  DST,SRC;    OP  DST,SRC,0xa7;   ENDM
    pfsubr  MACRO   DST,SRC;    OP  DST,SRC,0xaa;   ENDM
    pfacc   MACRO   DST,SRC;    OP  DST,SRC,0xae;   ENDM
    pfcmpeq MACRO   DST,SRC;    OP  DST,SRC,0xb0;   ENDM
    pfmul   MACRO   DST,SRC;    OP  DST,SRC,0xb4;   ENDM
    pfrcpit2 MACRO  DST,SRC;    OP  DST,SRC,0xb6;   ENDM
    pfmulhrw MACRO  DST,SRC;    OP  DST,SRC,0xb7;   ENDM
    pswapd  MACRO   DST,SRC;    OP  DST,SRC,0xbb;   ENDM
    pavgusb MACRO   DST,SRC;    OP  DST,SRC,0xbf;   ENDM
    prefetch MACRO  SRC; db 0x0f,0x0d; OP0 0x00,SRC;ENDM
    prefetchw MACRO SRC; db 0x0f,0x0d; OP0 0x01,SRC;ENDM
}
#endif
